/*
***********************************************************************
China Mine version 1.1
Copyright (C) 1998, 1999, 2000  Ma Guokai, from People's Republic of China

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

If what you get is only part of the program, send an email to akey@fudan.edu
give the name of the program and the version number (newest by default), I'll
send you a copy of the full package.
*****************************************************************************
*/

import java.awt.*;

class AboutChinaMine extends Dialog
{
	Label label1=new Label(Constant.languages[Config.language].Chinamine,Label.LEFT);
	Label label2=new Label(Constant.languages[Config.language].versionInfo,Label.LEFT);
	Label label3=new Label(Constant.languages[Config.language].cprtInfo1,Label.LEFT);
	Label label4=new Label(Constant.languages[Config.language].cprtInfo2,Label.LEFT);
	Label label5=new Label(Constant.languages[Config.language].cprtDetail,Label.LEFT);
	Button OKButton=new Button(Constant.languages[Config.language].ok);
	ShowImage icon=new ShowImage(Constant.styles[Config.style].icon);
	ShowImage akey=new ShowImage(Constant.akeyIcon);

	public AboutChinaMine()
	{
		super(Constant.onlyFrame, Constant.languages[Config.language].aboutString, false);
		setLocation(200,200);
		GridBagConstraints gbc=new GridBagConstraints();
		GridBagLayout layout=new GridBagLayout();
		setLayout(layout);

		gbc.insets=new Insets(10,10,0,20);
		gbc.gridx=0;
		gbc.gridy=0;
		gbc.gridheight=4;
		gbc.anchor=GridBagConstraints.NORTH;
		layout.setConstraints(icon,gbc);

		gbc.insets=new Insets(0,0,0,10);
		gbc.gridx=2;
		gbc.gridy=0;
		gbc.gridheight=2;
		gbc.anchor=GridBagConstraints.EAST;
		layout.setConstraints(akey,gbc);

		gbc.anchor=GridBagConstraints.WEST;
		gbc.insets=new Insets(15,0,0,10);
		gbc.gridx=1;
		gbc.gridy=0;
		gbc.gridheight=1;
		layout.setConstraints(label1,gbc);

		gbc.insets=new Insets(0,0,0,10);
		gbc.gridx=1;
		gbc.gridy=1;
		layout.setConstraints(label2,gbc);

		gbc.gridx=1;
		gbc.gridy=2;
		gbc.gridwidth=2;
		layout.setConstraints(label3,gbc);

		gbc.gridx=1;
		gbc.gridy=3;
		layout.setConstraints(label4,gbc);

		gbc.gridx=1;
		gbc.gridy=4;
		layout.setConstraints(label4,gbc);

		gbc.gridx=1;
		gbc.gridy=5;
		layout.setConstraints(label5,gbc);

		gbc.anchor=GridBagConstraints.EAST;
		gbc.insets=new Insets(10,0,10,10);
		gbc.ipadx=45;
		gbc.gridx=1;
		gbc.gridy=6;
		gbc.gridwidth=2;
		layout.setConstraints(OKButton,gbc);

		add(icon);
		add(akey);
		add(label1);
		add(label2);
		add(label3);
		add(label4);
		add(label5);
		add(OKButton);
		pack();
		setResizable(false);
		OKButton.requestFocus();
		show();
	}

	public boolean action(Event evt,Object what)
	{
		if(evt.target instanceof Button)
		{
			setVisible(false);
			Constant.resume();
			return true;
		}
		return true;
	}

	public boolean handleEvent(Event evt)
	{
		if(evt.id==Event.WINDOW_DESTROY)
		{
			setVisible(false);
			Constant.resume();
			return true;
		}
		return super.handleEvent(evt);
	}
	
	public boolean keyDown(Event evt, int key)
	{
		if(key==27)//ESC
		{
			setVisible(false);
			Constant.resume();
			return true;
		}
		return super.keyDown(evt,key);
	}
}