/*
***********************************************************************
China Mine version 1.1
Copyright (C) 1998, 1999, 2000  Ma Guokai, from People's Republic of China

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

If what you get is only part of the program, send an email to akey@fudan.edu
give the name of the program and the version number (newest by default), I'll
send you a copy of the full package.
*****************************************************************************
*/

import java.io.*;
import java.applet.*;
import java.net.*;
import java.util.*;

// This class contains user configration, and is write and read method
public class Config
{
	public static int level=0;
//when you start from an applet, the initial setting was "expert"
	public static boolean hotKeyEnabled=true;
	public static int language=-1;
	public static int style=0;
	public static int xPos=0, yPos=0;
	public static boolean canTag=true;

	public static void loadConfig()
	{
		BufferedReader br=null, brLang=null;
		boolean needResetWinner=true;
		if(Constant.isApplet)
		{
			Applet app=Constant.topApplet;
			try
			{
				language=Integer.valueOf(app.getParameter("language")).intValue();
			}
			catch(NullPointerException e){}
			catch(NumberFormatException e){}
			if(language<0||language>=Constant.LANGUAGE)
				language=-1;

			try
			{
				level=Integer.valueOf(app.getParameter("startLevel")).intValue();
			}
			catch(NullPointerException e){}
			catch(NumberFormatException e){}
			if(level>=Constant.levels.length || level<0)
				level=0;

			try
			{
				style=Integer.valueOf(app.getParameter("startStyle")).intValue();
			}
			catch(NullPointerException e){}
			catch(NumberFormatException e){}
			if(style<0)
				style=0;

			try
			{
				Constant.mineCGIstring=app.getParameter("mineCGI");
				Constant.mineCGIurl=new URL(Constant.mineCGIstring);
			}
			catch(MalformedURLException e){}
			catch(NullPointerException e){}

			try
			{
				URL styleURL=new
						URL(app.getCodeBase(), "styles.ini");
				br=new BufferedReader(new InputStreamReader(styleURL.openStream()));
				URL langURL=new
						URL(app.getCodeBase(), "language.ini");
				brLang=new BufferedReader(new InputStreamReader(langURL.openStream()));
			}
			catch(MalformedURLException e){}
			catch(IOException e){}
			catch(NullPointerException e){}
		}
		else // is application
		{
			try
			{
				//read old recodes
				File iniFile=new File("ChinaMine.ini");
				if(iniFile.exists() && iniFile.isFile() && iniFile.canRead())
				{
					BufferedReader br2=new BufferedReader(new FileReader(iniFile));
					level=Integer.valueOf(br2.readLine()).intValue();
					xPos=Integer.valueOf(br2.readLine()).intValue();
					yPos=Integer.valueOf(br2.readLine()).intValue();
					hotKeyEnabled=Boolean.valueOf(br2.readLine()).booleanValue();
					canTag=Boolean.valueOf(br2.readLine()).booleanValue();
					style=Integer.valueOf(br2.readLine()).intValue();
					language=Integer.valueOf(br2.readLine()).intValue();
					for(int i=0; i<Constant.levels.length; i++)
					{
						Constant.levels[i].winnerName=br2.readLine();
						Constant.levels[i].winnerScore=Integer.valueOf(br2.readLine()).intValue();
						Constant.levels[i].winnerNameWithoutTag=br2.readLine();
						Constant.levels[i].winnerScoreWithoutTag=Integer.valueOf(br2.readLine()).intValue();
						if(Constant.levels[i].winnerScore<0 || Constant.levels[i].winnerScore>999)
							Constant.levels[i].winnerScore=999;
						if(Constant.levels[i].winnerScoreWithoutTag<0 || Constant.levels[i].winnerScoreWithoutTag>999)
							Constant.levels[i].winnerScoreWithoutTag=999;
					}
					needResetWinner=false;
					br2.close();
				}
				iniFile=new File("styles.ini");
				if(iniFile.exists() && iniFile.isFile() && iniFile.canRead())
				{
					br=new BufferedReader(new FileReader(iniFile));
				}
				iniFile=new File("language.ini");
				if(iniFile.exists() && iniFile.isFile() && iniFile.canRead())
				{
					brLang=new BufferedReader(new FileReader(iniFile));
				}
			}
			catch(IOException e){}
		}

		if(language<0)
		{
			language=0;
			Locale currentLocale=Locale.getDefault();
			if(currentLocale.getLanguage()=="zh")
			{
				language=1;
				if(currentLocale.getVariant()=="TW")
					language=0;
			}
		}
		int styleNumber=0;
		try
		{
			styleNumber=Integer.valueOf(br.readLine()).intValue();
		}
		catch(IOException e){}
		catch(NullPointerException e){}
		catch(NumberFormatException e){}
		if(styleNumber<=0)
			styleNumber=1;
		Constant.styles=new StyleConst[styleNumber];
		String name="Super Scribble", folderName="scribble2";
		int i=0;
		try
		{
			for(i=0;i<styleNumber;i++)
			{
				name=br.readLine();
				folderName=br.readLine();
				if(name==null || folderName==null)
					break;
				Constant.styles[i]=new StyleConst(name, folderName);
			}
		}
		catch(IOException e){}
		catch(NullPointerException e){}
		for(;i<styleNumber;i++)
			Constant.styles[i]=new StyleConst(name, folderName);

		if(style<0 || style>=styleNumber)
			style=0;
		try
		{
			br.close();
		}
		catch(IOException e){}
		catch(NullPointerException e){}

		int languageNumber=0;
		try
		{
			languageNumber=Integer.valueOf(brLang.readLine()).intValue();
		}
		catch(IOException e){}
		catch(NullPointerException e){}
		catch(NumberFormatException e){}
		if(languageNumber<=0)
			languageNumber=1;
		Constant.languages=new LanguageStrings[languageNumber];
		name="English";
		String resourceName="english.lng";
		i=0;
		try
		{
			for(i=0;i<languageNumber;i++)
			{
				name=brLang.readLine();
				resourceName=brLang.readLine();
				if(name==null || resourceName==null)
					break;
				Constant.languages[i]=new LanguageStrings(name, resourceName);
			}
		}
		catch(IOException e){}
		catch(NullPointerException e){}
		for(;i<languageNumber;i++)
			Constant.languages[i]=new LanguageStrings(name, resourceName);

		if(language<0 || language>=styleNumber)
			language=0;
		try
		{
			brLang.close();
		}
		catch(IOException e){}
		catch(NullPointerException e){}
		Constant.languages[language].loadLanguage();
		if(needResetWinner)
			for(i=0;i<Constant.levels.length;i++)
				Constant.levels[i].resetWinner();
	}

	public static void saveConfig()
	{
		if(!Constant.isApplet)
		{
			try
			{
				File iniFile=new File("ChinaMine.ini");
				if( (iniFile.exists() && iniFile.isFile() && iniFile.canWrite())
						|| (!iniFile.exists()))
				{
					PrintWriter pw=new PrintWriter(new BufferedWriter(new FileWriter(iniFile)));
					pw.println(level);
					pw.println(xPos);
					pw.println(yPos);
					pw.println(hotKeyEnabled);
					pw.println(canTag);
					pw.println(style);
					pw.println(language);
					for(int i=0; i<Constant.levels.length; i++)
					{
						pw.println(Constant.levels[i].winnerName);
						pw.println(Constant.levels[i].winnerScore);
						pw.println(Constant.levels[i].winnerNameWithoutTag);
						pw.println(Constant.levels[i].winnerScoreWithoutTag);
					}
					pw.close();
				}
			}
			catch(IOException e){}
		}
	}
}
