/*
***********************************************************************
China Mine version 1.1
Copyright (C) 1998, 1999, 2000  Ma Guokai, from People's Republic of China

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

If what you get is only part of the program, send an email to akey@fudan.edu
give the name of the program and the version number (newest by default), I'll
send you a copy of the full package.
*****************************************************************************
*/

import java.awt.*;

public class Incompatiable extends Frame
{
	static boolean alive=false;
	boolean applet;

	public static boolean isAlive()
	{
		return alive;
	}

	public static boolean incompatiable()
	{
		try
		{
			Class.forName("java.awt.event.MouseEvent");
		}
		catch(ClassNotFoundException e)
		{
			return true;
		}
		return false;
	}

	public Incompatiable(boolean applet)
	{
		super("Error!");
		this.applet=applet;
		Label label=new Label("Your browser must support Java 1.1 or above.");
		Button ok=new Button("OK");
		move(200, 200);
		add("Center", label);
		add("South", ok);
		pack();
		show();
		ok.requestFocus();
		alive=true;
	}

	public boolean action(Event evt,Object what)
	{
		if(evt.target instanceof Button)
		{
			hide();
			alive=false;
			if(!applet)
				System.exit(0);
			return true;
		}
		return true;
	}

	public boolean handleEvent(Event evt)
	{
		if(evt.id==Event.WINDOW_DESTROY)
		{
			hide();
			alive=false;
			if(!applet)
				System.exit(0);
			return true;
		}
		return super.handleEvent(evt);
	}
	
	public boolean keyDown(Event evt, int key)
	{
		if(key==27)//ESC
		{
			hide();
			alive=false;
			if(!applet)
				System.exit(0);
			return true;
		}
		return super.keyDown(evt,key);
	}
}