/*
***********************************************************************
China Mine version 1.1
Copyright (C) 1998, 1999, 2000  Ma Guokai, from People's Republic of China

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

If what you get is only part of the program, send an email to akey@fudan.edu
give the name of the program and the version number (newest by default), I'll
send you a copy of the full package.
*****************************************************************************
*/

import java.awt.*;

class ShowBestTime extends Dialog
{
	Button anReset=new Button(Constant.languages[Config.language].resetScore);
	Button anOK=new Button(Constant.languages[Config.language].ok);
	Label level=new Label(Constant.languages[Config.language].bestTimeDialogLevel, Label.LEFT),
			time1=new Label(Constant.languages[Config.language].bestTimeDialogTime, Label.LEFT),
			name1=new Label(Constant.languages[Config.language].bestTimeDialogName, Label.LEFT),
			time2=new Label(Constant.languages[Config.language].bestTimeDialogTime2, Label.LEFT),
			name2=new Label(Constant.languages[Config.language].bestTimeDialogName2, Label.LEFT);
	Label[] levelLabel=new Label[Constant.levels.length];
	Label[] timeLabel=new Label[Constant.levels.length];
	Label[] nameLabel=new Label[Constant.levels.length];
	Label[] timeLabelNotag=new Label[Constant.levels.length];
	Label[] nameLabelNotag=new Label[Constant.levels.length];
	Label[] seperateLabel=new Label[Constant.levels.length];

	public ShowBestTime()
	{
		super(Constant.onlyFrame, Constant.languages[Config.language].fastestSweeper, false);
		for(int i=0;i<levelLabel.length;i++)
		{
			levelLabel[i]=new Label(Constant.levels[i].levelNameWithColonMark,Label.LEFT);
			timeLabel[i]=new Label("",Label.LEFT);
			nameLabel[i]=new Label("",Label.LEFT);
			timeLabelNotag[i]=new Label("",Label.LEFT);
			nameLabelNotag[i]=new Label("",Label.LEFT);
			seperateLabel[i]=new Label("-", Label.CENTER);
		}
		setLocation(150,150);
		GridBagConstraints gbc=new GridBagConstraints();
		GridBagLayout layout=new GridBagLayout();
		setLayout(layout);

		gbc.anchor=GridBagConstraints.WEST;
		gbc.fill=GridBagConstraints.HORIZONTAL;
		gbc.gridwidth=1;
		gbc.gridy=0;
		gbc.insets=new Insets(20, 20, 5, 0);
		gbc.gridx=0;
		layout.setConstraints(level, gbc);
		gbc.insets=new Insets(20, 0, 5, 0);
		gbc.gridx=1;
		layout.setConstraints(time1, gbc);
		gbc.gridx=2;
		layout.setConstraints(name1, gbc);
		gbc.gridx=4;
		layout.setConstraints(time2, gbc);
		gbc.insets=new Insets(20, 0, 5, 20);
		gbc.gridx=5;
		layout.setConstraints(name2, gbc);

		gbc.gridx=0;
		gbc.insets=new Insets(0, 20, 0, 0);
		for(int i=0;i<levelLabel.length;i++)
		{
			gbc.gridy=i+1;
			layout.setConstraints(levelLabel[i],gbc);
		}

		gbc.gridx=1;
		gbc.insets=new Insets(0, 0, 0, 0);
		for(int i=0;i<levelLabel.length;i++)
		{
			gbc.gridy=i+1;
			layout.setConstraints(timeLabel[i],gbc);
		}

		gbc.gridx=2;
		gbc.insets=new Insets(0, 0, 0, 0);
		for(int i=0;i<levelLabel.length;i++)
		{
			gbc.gridy=i+1;
			layout.setConstraints(nameLabel[i],gbc);
		}

		gbc.gridx=3;
		gbc.insets=new Insets(0, 0, 0, 0);
		for(int i=0;i<levelLabel.length;i++)
		{
			gbc.gridy=i+1;
			layout.setConstraints(seperateLabel[i],gbc);
		}

		gbc.gridx=4;
		gbc.insets=new Insets(0, 0, 0, 0);
		for(int i=0;i<levelLabel.length;i++)
		{
			gbc.gridy=i+1;
			layout.setConstraints(timeLabelNotag[i],gbc);
		}

		gbc.gridx=5;
		gbc.insets=new Insets(0, 0, 0, 20);
		for(int i=0;i<levelLabel.length;i++)
		{
			gbc.gridy=i+1;
			layout.setConstraints(nameLabelNotag[i],gbc);
		}

		gbc.fill=GridBagConstraints.NONE;
		gbc.anchor=GridBagConstraints.CENTER;

		gbc.gridx=1;
		gbc.gridy=levelLabel.length+1;
		gbc.gridwidth=2;
		gbc.insets=new Insets(15,0,15,0);
		gbc.anchor=GridBagConstraints.CENTER;
		layout.setConstraints(anReset,gbc);

		gbc.insets=new Insets(15,0,15,0);
		gbc.gridx=3;
		gbc.gridy=levelLabel.length+1;
		gbc.gridwidth=1;
		gbc.ipadx=20;
		gbc.anchor=GridBagConstraints.WEST;
		layout.setConstraints(anOK,gbc);

		add(level);
		add(time1);
		add(time2);
		add(name1);
		add(name2);
		for(int i=0;i<levelLabel.length;i++)
		{
			add(levelLabel[i]);
			add(timeLabel[i]);
			add(nameLabel[i]);
			add(seperateLabel[i]);
			add(timeLabelNotag[i]);
			add(nameLabelNotag[i]);
		}
		add(anOK);
		add(anReset);
		for(int i=0;i<levelLabel.length;i++)
		{
			nameLabel[i].setText(Constant.levels[i].winnerName);
			timeLabel[i].setText(Constant.levels[i].winnerScore+Constant.languages[Config.language].secondsString);
			nameLabelNotag[i].setText(Constant.levels[i].winnerNameWithoutTag);
			timeLabelNotag[i].setText(Constant.levels[i].winnerScoreWithoutTag+Constant.languages[Config.language].secondsString);
		}
		pack();
		setResizable(false);
		anOK.requestFocus();
		show();
	}

	public boolean action(Event evt,Object what)
	{
		if(evt.target instanceof Button)
		{
			if( evt.target==anOK)
			{
				setVisible(false);
				Constant.resume();
				return true;
			}
			else
			{
				for(int i=0;i<levelLabel.length;i++)
				{
					Constant.levels[i].resetWinner();
					nameLabel[i].setText(Constant.languages[Config.language].anonymousName);
					timeLabel[i].setText(Constant.anonymousTime+Constant.languages[Config.language].secondsString);
					nameLabelNotag[i].setText(Constant.languages[Config.language].anonymousName);
					timeLabelNotag[i].setText(Constant.anonymousTime+Constant.languages[Config.language].secondsString);
				}
				pack();
				return true;
			}
		}
		return true;
	}

	public boolean handleEvent(Event evt)
	{
		if(evt.id==Event.WINDOW_DESTROY)
		{
			setVisible(false);
			Constant.resume();
			return true;
		}
		return super.handleEvent(evt);
	}
	
	public boolean keyDown(Event evt, int key)
	{
		if(key==27)//ESC
		{
			setVisible(false);
			Constant.resume();
			return true;
		}
		return super.keyDown(evt,key);
	}
}