/*
***********************************************************************
China Mine version 1.1
Copyright (C) 1998, 1999, 2000  Ma Guokai, from People's Republic of China

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

If what you get is only part of the program, send an email to akey@fudan.edu
give the name of the program and the version number (newest by default), I'll
send you a copy of the full package.
*****************************************************************************
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include "misc.h"
#include "counter.h"
#include "http.h"

static FILE* fp;
int countNumber, countNumberToday, year, month, day, hour, minute, weekDay;

void addCounter()
{

	if(argc!=4)
		showError("Wrong args in count player function.");
	getCounter(1);
	puts("ok");
}

void getCounter(int incr)
{
	struct tm *ltime;
	time_t tim;

	tim=time(NULL);
	ltime=localtime(&tim);

	makeFilename(COUNTER);
	if(!(fp=fopen(buffer, "rb+")))
	{
		if(!(fp=fopen(buffer, "wb+")))
			showError("Can't open the count file for write.");
		if(fputs("0\n0\n0\n0\n0\n0\n0\n0\n", fp))
			showError("I/O error in counter function: fputs.");
		if(fseek(fp, 0, SEEK_SET))
			showError("I/O error in counter function: fseek.");
	}
	readBuffer(fp);
	countNumber=atoi(buffer);
	readBuffer(fp);
	countNumberToday=atoi(buffer);
	readBuffer(fp);
	year=atoi(buffer);
	readBuffer(fp);
	month=atoi(buffer);
	readBuffer(fp);
	day=atoi(buffer);
	readBuffer(fp);
	hour=atoi(buffer);
	readBuffer(fp);
	minute=atoi(buffer);
	readBuffer(fp);
	weekDay=atoi(buffer);
	if(year!=ltime->tm_year || month!=ltime->tm_mon || day!=ltime->tm_mday)
		countNumberToday=0;
	if(incr)
	{
		year=ltime->tm_year;
		month=ltime->tm_mon;
		day=ltime->tm_mday;
		hour=ltime->tm_hour;
		minute=ltime->tm_min;
		weekDay=ltime->tm_wday;
		if(fseek(fp, 0, SEEK_SET))
			showError("I/O error in counter function: fseek.");

		writeNum(countNumber+1, fp);
		writeNum(countNumberToday+1, fp);
		writeNum(year, fp);
		writeNum(month, fp);
		writeNum(day, fp);
		writeNum(hour, fp);
		writeNum(minute, fp);
		writeNum(weekDay, fp);
	}
	if(fclose(fp))
		showError("I/O error in counter function: fclose.");
	return;
}

