/*
***********************************************************************
China Mine version 1.1
Copyright (C) 1998, 1999, 2000  Ma Guokai, from People's Republic of China

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

If what you get is only part of the program, send an email to akey@fudan.edu
give the name of the program and the version number (newest by default), I'll
send you a copy of the full package.
*****************************************************************************
*/

#include "misc.h"
#include "http.h"
#include <string.h>
#include <stdlib.h>

byte buffer[1024];
int argc;
char** argv;

int startFrom(char* string, char* head)
{
	for(;(*string) && (*head) && (*(string++)==*(head++));)
		;
	return !(*head);
}

int writeInt16(FILE* iniFile, int number)
{
	byte buffer[2];

	buffer[0]=(byte)(number);
	buffer[1]=(byte)(number/256);
	if(fwrite(buffer, 2, 1, iniFile)!=1)
		return -1;
	return 0;
}

int readInt16(FILE* iniFile)
{
	byte buffer[2];

	if(fread(buffer, 2, 1, iniFile)!=1)
		return -1;
	return  buffer[0]+buffer[1]*256;
}

void makeFilename(char* filename)
{
	strcpy(buffer, argv[1]);
	strcat(buffer, filename);
}

void leaveTrace(char* tracename)
{
	static FILE *debug=NULL;

	if(debug==NULL)
		debug=fopen("debug.log", "w");
	fprintf(debug, "%s\n", tracename);
	fflush(debug);
}

char* newString(char* buffer)
{
	char* temp;
	temp=(char*)malloc(strlen(buffer)+1);
	if(!temp)
		showError("Not enough memory.");
	strcpy(temp, buffer);
	return temp;
}

void readBuffer(FILE* fp)
{
	int temp;

	if(!fgets(buffer, 1024, fp))
		showError("Can not read the file.");
	temp=strlen(buffer)-1;
	if(buffer[temp]=='\n')
		buffer[temp]='\0';
}

void writeNum(int num, FILE* fp)
{
	itoa(num, buffer, 10);
	if(fputs(buffer, fp))
		showError("I/O error in counter function: fputs.");
	if(fputs("\n", fp))
		showError("I/O error in counter function: fputs.");
}
