/*
***********************************************************************
China Mine version 1.1
Copyright (C) 1998, 1999, 2000  Ma Guokai, from People's Republic of China

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

If what you get is only part of the program, send an email to akey@fudan.edu
give the name of the program and the version number (newest by default), I'll
send you a copy of the full package.
*****************************************************************************
*/

#include <stdio.h>
#include <time.h>
#include "recordFile.h"

int readRecord(FILE* iniFile, int offset, int index, winnerData* returnValue)
/* return 0 means success, -1 means failure */
{
	byte buffer[blockSize];

	if(fseek(iniFile, offset+blockSize*(long)index, SEEK_SET))
		return -1;
	if(fread(buffer, blockSize, 1, iniFile)!=1)
		return -1;
	bytesToRecord(buffer, returnValue);
	return 0;
}

int writeRecord(FILE* iniFile, int offset, int index, winnerData* inputValue)
{
	byte buffer[blockSize];
	int i;

	if(fseek(iniFile, offset+blockSize*(long)index, SEEK_SET))
		return -1;
	buffer[0]=inputValue->levelNtag;
	buffer[1]=(byte)(inputValue->score);
	buffer[2]=(byte)((inputValue->score)/256);
	buffer[3]=(byte)(inputValue->year);
	buffer[4]=(byte)((inputValue->year)/256);
	buffer[5]=inputValue->month;
	buffer[6]=inputValue->day;
	buffer[7]=inputValue->weekDay;
	buffer[8]=inputValue->hour;
	buffer[9]=inputValue->minute;
	for(i=0;i<nameLength;i++)
		buffer[i+headLength]=inputValue->name[i];
	for(i=0;i<commentLength;i++)
		buffer[i+headLength+nameLength]=inputValue->comment[i];
	if(fwrite(buffer, blockSize, 1, iniFile)!=1)
		return -1;
	return 0;
}

void bytesToRecord(byte buffer[blockSize], winnerData* returnValue)
{
	int i;

	returnValue->levelNtag=(byte)buffer[0];
	returnValue->score=(dByte)(buffer[1]+buffer[2]*256);
	returnValue->year=(dByte)(buffer[3]+buffer[4]*256);
	returnValue->month=(byte)buffer[5];
	returnValue->day=(byte)buffer[6];
	returnValue->weekDay=(byte)buffer[7];
	returnValue->hour=(byte)buffer[8];
	returnValue->minute=(byte)buffer[9];
	for(i=0;i<nameLength;i++)
		returnValue->name[i]=(byte)buffer[i+headLength];
	for(i=0;i<commentLength;i++)
		returnValue->comment[i]=(byte)buffer[i+headLength+nameLength];
}

void touchRecord(winnerData* returnValue)
{
	struct tm* ltime;
	time_t tim;

	tim=time(NULL);
	ltime=localtime(&tim);
	returnValue->year=ltime->tm_year;
	returnValue->month=ltime->tm_mon;
	returnValue->day=ltime->tm_mday;
	returnValue->weekDay=ltime->tm_wday;
	returnValue->hour=ltime->tm_hour;
	returnValue->minute=ltime->tm_min;
}

